/*
 * config-hacks.h
 * Various hacks to the configuration for things that aren't
 *  automatically worked out.
 *
 * Copyright (c) 1996 T. J. Wilkinson & Associates, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@tjwassoc.demon.co.uk>
 */

/* Hacks to configure NeXT */
#if defined(NeXT)
#undef  HAVE_SYS_UTSNAME_H
#define HAVE_DYN_UNDERSTORE 1
#define	BLOCKING_CALLS
#endif

/* Hack to configure AmigaOS */
#if defined(__AMIGA__)
#define HAVE_DYN_UNDERSTORE 1
#define	BLOCKING_CALLS
#endif  

/* Hacks to configure SunOS & Solaris2 */
#if defined(__sun__)
#define	BLOCKING_CALLS
#endif

/* Hack for Window's */ 
#if !defined(__WIN32__) && (defined(WIN32) || defined(_WIN32))
#define __WIN32__ 1
#endif

/* Hack for NetBSD */
#if defined(__NetBSD__)
#define	HAVE_DYN_UNDERSTORE 1
#define	DEFAULT_LIBRARYPATH "/usr/local/lib:/usr/lib"
#endif
