/*
 * baseClasses.h
 * Handle base classes.
 *
 * Copyright (c) 1996 T. J. Wilkinson & Associates, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@tjwassoc.demon.co.uk>, 1996.
 */

#ifndef __baseclasses_h
#define __baseclasses_h

#include "object.h"

struct _stringClass {
	object		head;
	object*		value;
	int		offset;
	int		count;
};

#define	STRINGCLASS	"java/lang/String"
#define	STRINGINIT	"<init>"
#define	STRINGINITSIG	"([C)V"

#define	OBJECTCLASS	"java/lang/Object"
#define	CLASSCLASS	"java/lang/Class"

/*
 * Exception object.
 */
typedef struct _throwable {
	object			head;
	object*			backtrace;
	struct _stringClass*	message;
} throwable;

void		initBaseClasses(void);

extern Class*	ObjectClass;
extern Class*	ClassClass;
extern Class*	StringClass;

#endif
