/*
 * itypes.c
 * Internal types.
 *
 * Copyright (c) 1996 T. J. Wilkinson & Associates, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@tjwassoc.demon.co.uk>, 1996.
 */

#include "gtypes.h"
#include "itypes.h"
#include "baseClasses.h"

extern Utf8Const* makeUtf8Const (char*, int);

struct itypes types[MAXTYPES] = {
	/* 0 */			{ 0, ' ' },
	/* 1 */			{ 0, ' ' },
	/* 2 */			{ 0, ' ' },
	/* 3 */			{ 0, ' ' },
	/* TYPE_Boolean */	{ 1, 'Z' },
	/* TYPE_Char */		{ 2, 'C' },
	/* TYPE_Float */	{ 4, 'F' },
	/* TYPE_Double */	{ 8, 'D' },
	/* TYPE_Byte */		{ 1, 'B' },
	/* TYPE_Short */	{ 2, 'S' },
	/* TYPE_Int */		{ 4, 'I' },
	/* TYPE_Long */		{ 8, 'J' },
	/* 12 */		{ 0, ' ' },
	/* 13 */		{ 0, ' ' },
	/* 14 */		{ 0, ' ' },
	/* 15 */		{ sizeof(void*), 'L' },
};

/*
 * Intialise the internal types.
 */
void
initTypes(void)
{
	int i;
	char asig[2];
	asig[0] = '[';

	/* Translate strings */
	for (i = 0; i < MAXTYPES; i++) {
		asig[1] = types[i].sig;
		if (asig[1] != ' ') {
			types[i].arraySig = makeUtf8Const (asig, 2);
		}
	}
}

/*
 * Return the itypes information.
 */
struct itypes*
getITypes(void)
{
	return (types);
}
